Whamcloud - gitweb
b=11171
[fs/lustre-release.git] / lustre-iokit / obdfilter-survey / obdfilter-survey
index da0d797..2d85b8f 100755 (executable)
 ######################################################################
 # customize per survey
 
-# specify obd names (host:name if remote)
-# these can either be the echo_client names (client_names)
-# or the ost names (ost_names)
-#client_names=(ns8:ECHO_ns8 ns9:ECHO_ns9)
-ost_names=(ns9:ost{1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16})
-
-# result file prefix (date/time + hostname makes unique)
-rslt=/home_nfs/eeb/obdfilter_survey_`date +%F@%R`_`uname -n`
-
-# lustre root (if running with own source tree)
-lustre_root=/home_nfs/eeb/lustre
-
-# what to do (we always do an initial write)
-#tests="rewrite read reread rewrite_again"
-tests="rewrite read"
-
-# total size (MBytes) per OST
-# large enough to avoid cache effects 
-# and to make test startup/shutdown overhead insignificant
-size=8192
-
-# record size (KBytes)
-rszlo=1024
-rszhi=1024
-
-# number of objects per OST
-nobjlo=1
-nobjhi=512
-
-# threads per OST (1024 max)
-thrlo=1
-thrhi=64
-
-# restart from here iff all are defined
-restart_rsz=
-restart_thr=1
-restart_nobj=1
-
-# machine's page size
-PAGE_SIZE=64
-
-# max buffer_mem (total_threads * buffer size)
-# (to avoid lctl ENOMEM problems)
-max_buffer_mem=$((1024*1024))
-
-# how to run commands on other nodes
-custom_remote_shell () {
-    host=$1
-    shift
-    cmds="$*"
-    here=`pwd`
-    # Hop on to the remote node, chdir to 'here' and run the given
-    # commands. One of the following will probably work.
-    ssh $host "cd $here; $cmds"
-    #rsh $host "cd $here; $cmds"
-    #pdsh -w $host "cd $here; $cmds"
-}
-
-#####################################################################
-# leave the rest of this alone unless you know what you're doing...
-
-snap=1
-verify=1
-
-rsltf="${rslt}.summary"
-workf="${rslt}.detail"
-echo -n > $rsltf
-echo -n > $workf
-
-if [ -z "$lustre_root" ]; then
-    lctl=lctl
-else
-    lctl=${lustre_root}/utils/lctl
-fi
-
-remote_shell () {
-    host=$1
-    shift
-    cmds="$*"
-    if [ "$host" = "localhost" -o "$host" = `uname -n` ]; then
-       eval "$cmds"
-    else
-       custom_remote_shell $host "$cmds"
-    fi
-}
-
-check_obdecho() {
-    local host=$1
-    remote_shell $host lsmod | grep obdecho > /dev/null 2>&1
-}
-
-load_obdecho () {
-    local host=$1
-    if [ -z "$lustre_root" ]; then
-       remote_shell $host modprobe obdecho
-    elif [ -f ${lustre_root}/obdecho/obdecho.ko ]; then
-       remote_shell $host insmod ${lustre_root}/obdecho/obdecho.ko
-    else
-       remote_shell $host insmod ${lustre_root}/obdecho/obdecho.o
-    fi
-}
-
-unload_obdecho () {
-    local host=$1
-    remote_shell $host rmmod obdecho
-}
-
-get_devno () {
-    local host=$1
-    local type=$2
-    local name=$3
-    remote_shell $host $lctl device_list | \
-       awk "{if (\$2 == \"UP\" && \$3 == \"$type\" && \$4 == \"$name\") {\
-                 print \$1; exit}}"
-}
-
-get_ec_devno () {
-    local host=$1
-    local client_name="$2"
-    local ost_name="$3"
-    if [ -z "$client_name" ]; then
-       if [ -z "$ost_name" ]; then
-           echo "client and ost name both null" 1>&2
-           return
-       fi
-       client_name=${ost_name}_echo_client
-    fi
-    ec=`get_devno $host echo_client $client_name`
-    if [ -n "$ec" ]; then
-       echo $ec $client_name 0
-       return
-    fi
-    if [ -z "$ost_name" ]; then
-       echo "no echo client and ost_name not set" 1>&2
-       return
-    fi
-    ost=`get_devno $host obdfilter $ost_name`
-    if [ -z "$ost" ]; then
-       echo "OST $ost_name not setup" 1>&2
-       return
-    fi
-    remote_shell $host "$lctl <<EOF
-        attach echo_client $client_name ${client_name}_UUID
-       setup $ost_name
-EOF"
-    ec=`get_devno $host echo_client $client_name`
-    if [ -z "$ec" ]; then
-       echo "Can't setup echo client" 1>&2
-       return
-    fi
-    echo $ec $client_name 1
-}
-
-teardown_ec_devno () {
-    local host=$1
-    local client_name=$2
-    remote_shell $host "$lctl <<EOF
-       cfg $client_name
-       cleanup
-       detach
-EOF"
-}
-
+# specify obd instances to exercise
+# these can be either...
+# obdfilter instances (set 'ost_names')
+# ...or...
+# echo_client instances (set 'client_names')
+# ... use 'host:name' for obd instances on other nodes.
+# allow these to be passed in via string...
+# OR
+# one can specify only case=disk or case=network or case=netdisk through 
+# command line.
+
+# Perquisite: For "disk" case and "netdisk" case you need to have lustre setup
+#             with one or more ost's. For "network" case  you need to have all
+#             modules (those llmount.sh loades) loaded in kernel. And the 
+#             'lctl dl' output must be blank.
+
+# How to run test:
+# case 1 (local disk):
+#   $ nobjhi=2 thrhi=2 size=1024 case=disk sh obdfilter-survey
+#   instead of case=disk one can also run test as follows
+#   $ nobjhi=2 thrhi=2 size=1024 OSTS="lustre-OST0000 lustre-OST0001 ..." sh obdfilter-survey
+# case 2 (network):
+#   $ nobjhi=2 thrhi=2 size=1024 server_nid="<name/nid_of_server>" case=network sh obdfilter-survey
+#   where, server_nid is name or ip address of system, which you want to 
+#   set as server.
+# case 3 (network and disk):
+#   $ nobjhi=2 thrhi=2 size=1024 case=netdisk sh obdfilter-survey
+#   instead of case="netdisk" one can also run test as follows
+#   $ nobjhi=2 thrhi=2 size=1024 ECHO_CLIENTS="ECHO_<osc_name> ..." sh obdfilter-survey
+#[ NOTE: It is advised to have automated login (passwordless entry) between server and 
+#  client systems on which this test runs.]
+
+# include library 
+source libecho
+
+# create a set of objects, check there are 'n' contiguous ones and
+# return the first or 'ERROR'
+# parameter: 1. hostname
+#           2. device number
+#           3. number of object to be created (specified by user)
+#           4. tempfile name
 create_objects () {
-    # create a set of objects, check there are 'n' contiguous ones and
-    # return the first or 'ERROR'
     local host=$1
     local devno=$2
     local nobj=$3
     local rfile=$4
     remote_shell $host $lctl --device $devno create $nobj > $rfile 2>&1
-    n=(`awk < $rfile \
-       '/is object id/ {obj=strtonum($6);\
-                        first=!not_first; not_first=1;\
-                        if (first) first_obj=obj;
-                        else if (obj != prev + 1) exit;\
-                        prev=obj; n++}\
-            END {printf "%d %d\n", first_obj, n}'`)
-    if ((n[1] != nobj)); then
-       echo "ERROR"
-    else
-       echo ${n[0]}
+    first=0
+    prev=0
+    count=0
+    error=0
+    while read line; do
+        echo "$line" | grep -q 'is object id'
+        if [ $?  -ne 0 ]; then
+            continue
+        fi
+        if [ $first -eq 0 ]; then
+            first=$(echo $line | awk '{print $6}')
+            first=$(printf "%d" $first)
+            prev=$first
+            count=1
+        else
+            obj=$(echo $line | awk '{print $6}') 
+            obj=$(printf "%d" $obj) 
+            diff=$((obj - (prev+1))) 
+            if [ $diff -ne 0 ]; then 
+                error=1 
+            fi 
+            prev=$obj 
+            count=$((count+1)) 
+        fi 
+    done < $rfile 
+    if [ $nobj -ne $count ]; then 
+        echo "ERROR: $nobj != $count" >&2 
+        cat $rfile >&2 
+        echo "ERROR" 
+    elif [ $error -ne 0 ]; then 
+        echo "ERROR: non contiguous objs found" >&2 
+    else 
+        echo $first 
     fi
 }
 
+# destroys all objects created in create_objects routine
+# parameter: 3. start obj id.
 destroy_objects () {
     local host=$1
     local devno=$2
@@ -221,6 +121,8 @@ get_global_stats () {
                       printf "%d %f %f\n", err, min, max}'
 }
 
+# enable or disable data check.
+# parameter: 1. read/write
 testname2type () {
     # 'x' disables data check
     if ((verify)); then
@@ -236,37 +138,214 @@ testname2type () {
 
 print_summary () {
     if [ "$1" = "-n" ]; then
-       minusn=$1; shift
+        minusn=$1; shift
     else
-       minusn=""
+        minusn=""
     fi
     echo $minusn "$*" >> $rsltf
     echo $minusn "$*"
 }
 
-unique () {
-    echo "$@" | xargs -n1 echo | sort -u
-}
+# Customisation variables
+#####################################################################
+# One can change variable values in this section as per requirements
+
+OSTS=${OSTS:-""}
+server_nid=${server_nid:-""}
+case=${case:-"disk"}
+if [ -n "$OSTS" ]; then
+    declare -a ost_names
+    count=0
+    for name in $OSTS; do
+        ost_names[$count]=$name
+        count=$((count+1))
+    done
+fi
+ECHO_CLIENTS=${ECHO_CLIENTS:-""}
+if [ -n "$ECHO_CLIENTS" ]; then
+    # make sure we unset ost_names so that our client_names get noticed... 
+    unset ost_names
+    declare -a client_names
+    count=0
+    for name in $ECHO_CLIENTS; do
+        client_names[$count]=$name
+        count=$((count+1))
+    done
+fi
 
-split_hostname () {
-    name=$1
-    case $name in
-    *:*) host=`echo $name | sed 's/:.*$//'`
-        name=`echo $name | sed 's/[^:]*://'`
-        ;;
-    *)   host=localhost
-        ;;
-    esac
-    echo "$host $name"
-}
+# result file prefix (date/time + hostname makes unique)
+# NB ensure path to it exists
+rslt=${rslt:-"/tmp/obdfilter_survey_`date +%F@%R`_`uname -n`"}
+
+# what tests to run (first must be write)
+tests_str=${tests_str:-""}
+if [ -n "$tests_str" ]; then
+    declare -a tests
+    count=0
+    for name in $tests_str; do
+        tests[$count]=$name
+        count=$((count+1))
+    done
+else
+    #tests=(write rewrite read reread rewrite_again)
+    tests=(write rewrite read)
+fi
+
+# Set this true to check file contents
+verify=0
+
+# total size (MBytes) per obd instance
+# large enough to avoid cache effects 
+# and to make test startup/shutdown overhead insignificant
+size=${size:-16384}
+
+# record size (KBytes)
+rszlo=${rszlo:-1024}
+rszhi=${rszhi:-1024}
+
+# number of objects per OST
+nobjlo=${nobjlo:-1}
+#was nobjhi=${nobjhi:-512}
+nobjhi=${nobjhi:-16}
+
+# threads per OST (1024 max)
+thrlo=${thrlo:-1}
+thrhi=${thrhi:-16}
+
+# restart from here iff all are defined
+restart_rsz=
+restart_thr=1
+restart_nobj=1
+
+# machine's page size (K)
+if [ -z "$PAGE_SIZE" ]; then
+    if which python >/dev/null; then
+       PAGE_SIZE=`echo 'import resource; print resource.getpagesize()/1024;' |python`
+    fi
+fi
+PAGE_SIZE=${PAGE_SIZE:-4}
+
+# max buffer_mem (total_threads * buffer size)
+# (to avoid lctl ENOMEM problems)
+max_buffer_mem=$((1024 * 1024))
+snap=1
+
+# Customisation variables ends here. 
+#####################################################################
+# leave the rest of this alone unless you know what you're doing...
+
+if [ ${#tests[@]} -eq 0 -o "${tests[0]}" != "write" ]; then
+    echo "tests: ${tests[@]}"
+    echo "First test must be 'write'" 1>&2
+    exit 1
+fi
+
+rsltf="${rslt}.summary"
+workf="${rslt}.detail"
+cmdsf="${rslt}.script"
+vmstatf="${rslt}.vmstat"
+echo -n > $rsltf
+echo -n > $workf
+
+# hide a little trick to unset this from the command line
+if [ "$lustre_root" == " " ]; then
+    unset lustre_root
+fi
 
+if [ -z "$lustre_root" ]; then
+    lctl=lctl
+else
+    lctl=${lustre_root}/utils/lctl
+fi
+
+if [ $case == "network" ]; then
+    if [ -z "$server_nid" ]; then
+       echo "Specify the server NID"
+       exit 1;
+    fi
+    osc_names_string=`ssh root@"$server_nid" lctl dl`
+    count=0;
+    for name in $osc_names_str; do
+        count=$((count+1))
+    done
+
+    if [ $count != 0 ]; then
+        echo "The existing setup must be cleaned";
+        exit 0;
+    fi
+    # Now do the server setup
+    setup_srv_obd $server_nid "ost_testfs"
+    op_string=`ssh root@"$server_nid" lctl dl`
+    
+    obdecho=0
+    ost=0 
+    for name in $op_string; do
+       if [ "$name" = "obdecho" ]; then
+           obdecho=1
+       fi
+       if [ "$name" = "ost" ]; then
+           ost=1
+       fi
+    done
+
+    if (( $obdecho == 0 || $ost == 0 )); then
+       echo "Server setup not done properly"
+       exit 1
+    fi
+    # Now start client setup
+    osc_names_str=$(lctl dl)
+    if [ -n "$osc_names_str" ]; then
+        echo "The existing setup must be cleaned";
+        exit 0;
+    fi
+    ec_using_srv_nid $server_nid "osc_testfs" "test_obdfs"
+    declare -a client_names
+    client_names[0]="ECHO_osc_testfs"
+fi
+
+if [ -z "$ECHO_CLIENTS" ]; then
+    if [ $case == "netdisk" ]; then
+        declare -a osc_names
+        declare -a osc_uuids
+        osc_names_str=$(lctl dl |grep osc | awk "{if (\$2 == \"UP\" && \$3 == \"osc\") {print \$4} }")
+        count=0;
+        for name in $osc_names_str; do
+            osc_names[$count]=$name
+            count=$((count+1))
+        done
+        osc_uuid_str=$(lctl dl |grep osc | awk "{if (\$2 == \"UP\" && \$3 == \"osc\") {print \$5} }")
+        count=0;
+        for uuid in $osc_uuid_str; do
+            osc_uuids[$count]=$uuid
+            count=$((count+1))
+        done
+        for ((  i = 0 ;  i < $count;  i++  ))
+        do
+            ec_using_osc ${osc_names[$i]} ${osc_uuids[$i]}
+        done
+        ECHO_CLIENTS=$(lctl dl | grep echo_client | awk "{if (\$2 == \"UP\" && \$3 == \"echo_client\") {print \$4} }")
+        cnt=0;
+        for name in $ECHO_CLIENTS; do
+            client_names[$cnt]=$name
+            cnt=$((cnt+1))
+        done
+    fi
+fi
+
+if [ -z "$OSTS" ]; then
+    if [ $case == "disk" ]; then
+       get_targets     
+    fi 
+fi
+
+# split out hostnames from client/ost names
 ndevs=${#client_names[@]}
 if ((ndevs != 0)); then
     if ((${#ost_names[@]} != 0)); then
         echo "Please specify client_names or ost_names, but not both" 1>&2
        exit 1
     fi
-    for ((i=0; i<ndevs;i++)); do
+    for ((i = 0; i < ndevs; i++)); do
        str=(`split_hostname ${client_names[$i]}`)
        host_names[$i]=${str[0]}
        client_names[$i]=${str[1]}
@@ -277,31 +356,39 @@ else
         echo "Please specify either client_names or ost_names" 1>&2
        exit 1
     fi
-    for ((i=0; i<ndevs;i++)); do
+    for ((i = 0; i < ndevs; i++)); do
        str=(`split_hostname ${ost_names[$i]}`)
        host_names[$i]=${str[0]}
        ost_names[$i]=${str[1]}
     done
 fi
 
+# get vmstat started
+# disable portals debug and get obdecho loaded on all relevant hosts
 unique_hosts=(`unique ${host_names[@]}`)
-
+pidcount=0
 for host in ${unique_hosts[@]}; do
-    remote_shell $host "echo 0 > /proc/sys/portals/debug"
+    host_vmstatf=${vmstatf}_${host}
+    echo -n > $host_vmstatf
+    remote_shell $host "vmstat 5 >> $host_vmstatf" &
+    pid=$!
+    vmstatpids[$pidcount]=$pid
+    pidcount=$((pidcount+1))
     do_unload_obdecho[$host]=0
-    if check_obdecho $host; then
-       continue
+    if obdecho_loaded $host; then
+        continue
     fi
     load_obdecho $host
-    if check_obdecho $host; then
-       do_unload_obdecho[$host]=0
-       continue
-    fi
+    if obdecho_loaded $host; then
+        do_unload_obdecho[$host]=1
+        continue
+        fi
     echo "Can't load obdecho on $host" 1>&2
     exit 1
 done
 
-for ((i=0; i<ndevs; i++)); do
+# get all the echo_client device numbers and names
+for ((i=0; i < ndevs; i++)); do
     host=${host_names[$i]}
     devno=(`get_ec_devno $host "${client_names[$i]}" "${ost_names[$i]}"`)
     if ((${#devno[@]} != 3)); then
@@ -311,11 +398,10 @@ for ((i=0; i<ndevs; i++)); do
     client_names[$i]=${devno[1]}
     do_teardown_ec[$i]=${devno[2]}
 done
-
-for ((rsz=$rszlo;rsz<=$rszhi;rsz*=2)); do
-    for ((nobj=$nobjlo;nobj<=$nobjhi;nobj*=2)); do 
-       for ((thr=$thrlo;thr<=$thrhi;thr*=2)); do
-           if ((thr < nobj)); then
+for ((rsz = $rszlo; rsz <= $rszhi; rsz*=2)); do
+    for ((nobj = $nobjlo; nobj <= $nobjhi; nobj*=2)); do 
+       for ((thr = $thrlo; thr <= $thrhi; thr*=2)); do
+           if ((thr % nobj)); then
                continue
            fi
            # restart?
@@ -349,7 +435,7 @@ for ((rsz=$rszlo;rsz<=$rszhi;rsz*=2)); do
            fi
            # create the objects
            tmpf="${workf}_tmp"
-           for ((idx=0; idx < ndevs; idx++)); do
+           for ((idx = 0; idx < ndevs; idx++)); do
                host=${host_names[$idx]}
                devno=${devnos[$idx]}
                client_name="${host}:${client_names[$idx]}"
@@ -363,54 +449,81 @@ for ((rsz=$rszlo;rsz<=$rszhi;rsz*=2)); do
                fi
                first_objs[$idx]=$first_obj
            done
-           for test in write $tests; do
+           # run tests
+           for test in ${tests[@]}; do
+                declare -a pidarray
+                for host in ${unique_hosts[@]}; do
+                    echo "starting run for test: $test rsz: $rsz threads: $thr objects: $nobj" >> ${vmstatf}_${host}
+                done
                print_summary -n "$test "
+               # create per-host script files
                for host in ${unique_hosts[@]}; do
-                   echo -n > ${workf}_${host}_script
+                   echo -n > ${cmdsf}_${host}
                done
-               for ((idx=0; idx < ndevs; idx++)); do
+               for ((idx = 0; idx < ndevs; idx++)); do
                    host=${host_names[$idx]}
                    devno=${devnos[$idx]}
                    tmpfi="${tmpf}_$idx"
                    first_obj=${first_objs[$idx]}
-                   echo >> ${workf}_${host}_script \
+                   thr_per_obj=$((${thr}/${nobj}))
+                   echo >> ${cmdsf}_${host} \
                        "$lctl > $tmpfi 2>&1 \\
                          --threads $thr -$snap $devno \\
-                        test_brw $count `testname2type $test` q $pages ${thr}t${first_obj} &"
-               done
-               for host in ${unique_hosts[@]}; do
-                   echo "wait" >> ${workf}_${host}_script
-               done
-               t0=`date +%s.%N`
-               for host in ${unique_hosts[@]}; do
-                   remote_shell $host bash ${workf}_${host}_script&
-               done
-               wait
-               t1=`date +%s.%N`
-               for host in ${unique_hosts[@]}; do
-                   rm ${workf}_${host}_script
-               done
+                        test_brw $count `testname2type $test` q $pages ${thr_per_obj}t${first_obj} &"
+                done
+                pidcount=0
+                for host in ${unique_hosts[@]}; do
+                    echo "wait" >> ${cmdsf}_${host}
+                    pidarray[$pidcount]=0
+                    pidcount=$((pidcount+1))
+                done
+                # timed run of all the per-host script files
+                t0=`date +%s.%N`
+                pidcount=0
+                for host in ${unique_hosts[@]}; do
+                   # brutal hack to deal with a non-shared /tmp
+                   scp -q ${cmdsf}_${host} ${host}:/tmp > /dev/null
+                    remote_shell $host bash ${cmdsf}_${host} &
+                    pidarray[$pidcount]=$!
+                    pidcount=$((pidcount+1))
+                done
+                pidcount=0
+                for host in ${unique_hosts[@]}; do
+                    wait ${pidarray[$pidcount]}
+                    pidcount=$((pidcount+1))
+                done
+                #wait
+                t1=`date +%s.%N`
+                # clean up per-host script files
+                for host in ${unique_hosts[@]}; do
+                    rm ${cmdsf}_${host}
+                done
+               # compute bandwidth from total data / elapsed time
                str=`awk "BEGIN {printf \"%7.2f \",\
                         $total_size / (( $t1 - $t0 ) * 1024)}"`
                print_summary -n "$str"
+               # collect/check individual OST stats
                echo -n > $tmpf
-               for ((idx=0; idx < ndevs; idx++)); do
+               for ((idx = 0; idx < ndevs; idx++)); do
                    client_name="${host_names[$idx]}:${client_names[$idx]}"
                    tmpfi="${tmpf}_$idx"
                    echo "=============> $test $client_name" >> $workf
+                   host="${host_names[$idx]}"
+                   scp -q ${host}:$tmpfi $tmpfi > /dev/null
                    cat $tmpfi >> $workf
                    get_stats $tmpfi >> $tmpf
                    rm $tmpfi
                done
+               # compute/display global min/max stats
                echo "=============> $test global" >> $workf
                cat $tmpf >> $workf
                stats=(`get_global_stats $tmpf`)
                rm $tmpf
                if ((stats[0] <= 0)); then
                    if ((stats[0] < 0)); then
-                       str=`printf "%15s " ERROR`
+                       str=`printf "%17s " ERROR`
                    else
-                       str=`printf "%15s " SHORT`
+                       str=`printf "%17s " SHORT`
                    fi
                else
                    str=`awk "BEGIN {printf \"[%7.2f,%7.2f] \",\
@@ -420,7 +533,8 @@ for ((rsz=$rszlo;rsz<=$rszhi;rsz*=2)); do
                print_summary -n "$str"
            done
            print_summary ""
-           for ((idx=0; idx < ndevs; idx++)); do
+           # destroy objects we created
+           for ((idx = 0; idx < ndevs; idx++)); do
                host=${host_names[$idx]}
                devno=${devnos[$idx]}
                client_name="${host}:${client_names[$idx]}"
@@ -434,15 +548,5 @@ for ((rsz=$rszlo;rsz<=$rszhi;rsz*=2)); do
     done
 done
 
-for ((i=0; i<ndevs; i++)); do
-    host=${host_names[$i]}
-    if ((${do_teardown_ec[$i]})); then
-       teardown_ec_devno $host ${client_names[$i]}
-    fi
-done
-
-for host in ${unique_hosts[@]}; do
-    if ((${do_unload_obdecho[$host]})); then
-       unload_obdecho $host
-    fi
-done
+cleanup 0
+exit 0